#include <ncbi.h>
#include <gishlib.h>
#include "blastapp.h"

double
gapdecay(nsegs, p, decayrate)
	unsigned	nsegs; /* no. of gaps = nsegs - 1 */
	register double		p;
	register double		decayrate;
{
	if (decayrate > 0. && decayrate < 1. && nsegs > 0)
		p /= (1. - decayrate) * fct_powi(decayrate, nsegs - 1);

	return p;
}

/* inverse function of gapdecay() */
double
gapdecay_inverse(nsegs, p, decayrate)
	unsigned	nsegs;
	register double	p;
	register double	decayrate;
{
	if (decayrate > 0. && decayrate < 1. && nsegs > 0)
		p *= (1. - decayrate) * fct_powi(decayrate, nsegs - 1);
	return p;
}

void
report_gapdecayrate()
{
	if (gapdecayrate < 0. || gapdecayrate >= 1.)
		(void) printf("  -gapdecayrate deactivated");
	else
		(void) printf("  -gapdecayrate %lg", gapdecayrate);
	if (gapdecayrate == GAPDECAYRATE_DEFAULT)
		printf(" (the default)");
	putc('\n', stdout);
	return;
}
