#ifndef __GISHLIB__
#define __GISHLIB__
/* if not already included... */
#include <gish.h>

void aputc PROTO((int ch, FILE *fp));
int aprintf VPROTO((FILE *fp, CharPtr fmt, ...));
int awrite PROTO((Nlm_VoidPtr ptr, size_t size, size_t nitems, FILE *fp));

void _cdecl	AnyDataAssign PROTO((AnyDataPtr,int,AnyType,VoidPtr));
int _cdecl AnyDataCmp PROTO((AnyDataPtr,AnyDataPtr));

void _cdecl	LinkPreviousCreate PROTO((VoidPtr lp, size_t nextoff, size_t prevoff));
int _cdecl	LinkSort PROTO((VoidPtr PNTR list, size_t nextoff, int (* _cdecl cmpfunc)() ));
int _cdecl	DblLinkSort PROTO((VoidPtr PNTR list, size_t nextoff, size_t prevoff, int (* _cdecl cmpfunc)() ));

PoolBlkPtr _cdecl PoolNew PROTO((size_t nitems, size_t size, size_t nextoff, AnyDataPtr));
void _cdecl	PoolInit PROTO((PoolBlkPtr));
void _cdecl PoolDestruct PROTO((PoolBlkPtr));
VoidPtr _cdecl PoolGet PROTO((PoolBlkPtr));
VoidPtr _cdecl PoolGetClr PROTO((PoolBlkPtr));
void _cdecl PoolPut PROTO((PoolBlkPtr,VoidPtr));
void _cdecl PoolPutLink PROTO((PoolBlkPtr,VoidPtr));
int _cdecl	PoolContains PROTO((PoolBlkPtr,VoidPtr));

CharPtr _cdecl vstr_cpy PROTO((CharPtr PNTR base, size_t PNTR maxlen, CharPtr dst, CharPtr src));
int _cdecl vstr_cat PROTO((CharPtr PNTR dst, size_t PNTR maxlen, CharPtr src));

/*
	low-level string and memory manipulators.
	Some of these are patterned after UNIX string and bstring functions.
	(See "man 3 strings" and "man 3 bstring").
*/
CharPtr _cdecl	str_mov PROTO((CharPtr dst, CharPtr src));
CharPtr _cdecl	str_nmov PROTO((CharPtr dst, CharPtr src, size_t n));

CharPtr _cdecl	str_append PROTO((CharPtr dst, CharPtr src));
CharPtr _cdecl	str_nappend PROTO((CharPtr dst, CharPtr src, size_t n));

int _cdecl	str_ccmp PROTO((CharPtr s1, CharPtr s2));
int _cdecl	str_rcmp PROTO((CharPtr s1, CharPtr s2));

size_t _cdecl str_cnt PROTO((CharPtr s, CharPtr list));

int _cdecl	str_prefix PROTO((CharPtr s1, CharPtr s2));
int _cdecl	str_nprefix PROTO((CharPtr s1, CharPtr s2, size_t n));
int _cdecl	str_ncaseprefix PROTO((CharPtr s1, CharPtr s2, size_t n));

int _cdecl	str_suffix PROTO((CharPtr s1, CharPtr s2));
int _cdecl	str_nsuffix PROTO((CharPtr s1, CharPtr s2, size_t n));

CharPtr _cdecl	str_tail PROTO((CharPtr s));
CharPtr _cdecl	str_ntail PROTO((CharPtr s, size_t n));

int _cdecl	str_casecmp PROTO((CharPtr s1, CharPtr s2));
int _cdecl	str_ncasecmp PROTO((CharPtr s1, CharPtr s2, size_t n));

CharPtr _cdecl	str_dup PROTO((CharPtr s));

CharPtr _cdecl	str_chr PROTO((CharPtr s, int c));
CharPtr _cdecl	str_rchr PROTO((CharPtr s, int c));
CharPtr _cdecl	str_casechr PROTO((CharPtr s, int c));
CharPtr _cdecl	str_rcasechr PROTO((CharPtr s, int c));

void _cdecl	str_tolower PROTO((CharPtr s));
void _cdecl	str_toupper PROTO((CharPtr s));

/* Find start of substring */
CharPtr _cdecl	str_str PROTO((CharPtr s1, CharPtr s2));
CharPtr _cdecl	str_nstr PROTO((CharPtr s1, CharPtr s2, size_t n));

/* Find start of substring, case-independent search */
CharPtr _cdecl	str_casestr PROTO((CharPtr s1, CharPtr s2));
CharPtr _cdecl	str_ncasestr PROTO((CharPtr s1, CharPtr s2, size_t n));

CharPtr _cdecl	str_pbrk PROTO((CharPtr s1, CharPtr s2));

size_t _cdecl	str_spn PROTO((CharPtr s1, CharPtr s2));
size_t _cdecl	str_cspn PROTO((CharPtr s1, CharPtr s2));
CharPtr _cdecl	str_trim PROTO((CharPtr s, CharPtr list));

CharPtr _cdecl	str_tok PROTO((CharPtr s1, CharPtr s2));
void _cdecl	str_tr PROTO((CharPtr s, CharPtr to, CharPtr from, int defalt));


VoidPtr _cdecl mem_malloc PROTO((size_t size));
VoidPtr _cdecl mem_calloc PROTO((size_t nelem, size_t elsize));
VoidPtr _cdecl mem_realloc PROTO((VoidPtr oldptr, size_t newsize));
void _cdecl mem_free PROTO((VoidPtr));
Nlm_VoidPtr _cdecl	mem_ccpy PROTO((Nlm_VoidPtr dst, Nlm_VoidPtr src, int c, size_t len));
Nlm_VoidPtr _cdecl	mem_dup PROTO((Nlm_VoidPtr b, size_t n));
/* Find start of p in b */
Nlm_VoidPtr _cdecl	mem_index PROTO((Nlm_VoidPtr b, size_t blen, Nlm_VoidPtr p, size_t plen));

/* Miscellaneous functions */
CharPtr _cdecl	basename PROTO((CharPtr fname, CharPtr extension));
CharPtr _cdecl	dirname PROTO((CharPtr fname));
char * _cdecl ld2s PROTO((long));
char * _cdecl lu2s PROTO((unsigned long));
int _cdecl	longwidth10 PROTO((long));
int _cdecl	ulongwidth10 PROTO((unsigned long));
CharPtr _cdecl	vfgets PROTO((CharPtr PNTR base, size_t PNTR basemax, CharPtr PNTR bp, FILE *fp));
int _cdecl		wrap PROTO((FILE *fp, CharPtr title, CharPtr s, int slen, int linelen, int indent));

extern int	opterr, optind, optopt; /* feelers into getopt() */
extern char	*optarg;
int _cdecl		getopt PROTO((int nargc, char *const *nargv, const char *ostr));
void _cdecl	fatal VPROTO((int err, CharPtr format, ...));
FILE *openfile PROTO((char *fname, char *mode));
int _cdecl	getfasta PROTO((UcharPtr xltab, CharPtr PNTR name, size_t PNTR namemax, size_t PNTR namelen, UcharPtr PNTR buf0, size_t PNTR bufmax, size_t PNTR seqlen, FILE *fp));
int _cdecl	putfasta PROTO((CharPtr xltab, CharPtr prefix, size_t prefixlen, CharPtr name, size_t namelen, UcharPtr seq, size_t seqlen, FILE *fp));

int _cdecl	SameFd PROTO((int,int));
int _cdecl	SameFp PROTO((FILE *,FILE *));
long _cdecl	swap_long PROTO((long));
short _cdecl	swap_short PROTO((int));

TaskBlkPtr _cdecl	TaskNew PROTO((long, Nlm_VoidPtr, void (_cdecl*)(), long));
TaskBlkPtr _cdecl	TaskLink PROTO((TaskBlkPtr tp, unsigned id));
void _cdecl	TaskInit PROTO((TaskBlkPtr tp, int nchunks));
void _cdecl	TaskUnlink PROTO((TaskBlkPtr));
long _cdecl	TaskNext PROTO((TaskBlkPtr));
void _cdecl	TaskDestruct PROTO((TaskBlkPtr));
void _cdecl	TaskTickNext PROTO((TaskBlkPtr,long));

int _cdecl run_wild PROTO((unsigned long,void (_cdecl *)(),Nlm_VoidPtr,void (_cdecl *)(),unsigned long,int,int PNTR,void (_cdecl *)() ));
int _cdecl mrun_wild PROTO((unsigned long,void (_cdecl *)(),Nlm_VoidPtr,void (_cdecl *)(),unsigned long,int,int PNTR,void (_cdecl *)() ));


/* shared memory and other interprocess comm. */
int shmexists();
shm_dat	PNTR shm_attfile PROTO((CharPtr filename, CharPtr mode, int verbose));
key_t	shm_mkkey PROTO((CharPtr filename));
VoidPtr	shm_addr PROTO((shm_dat PNTR));
shm_dat	PNTR shm_loadfile PROTO((CharPtr filename, int mmode, int smode, int qmode, int lockfile, int verbose));
int	shm_detach PROTO((CharPtr));
int	shm_sendto PROTO((CharPtr filename, int sig));
int	shm_sendtokey PROTO((key_t key, int sig));

#ifndef mfil_open
MFILE	PNTR mfil_open PROTO((CharPtr name, CharPtr mode, int flags));
int _cdecl	mfil_inmemory PROTO((MFILE PNTR mfp));
long int _cdecl	mfil_tell PROTO((MFILE PNTR mfp));
int _cdecl mfil_seek PROTO((MFILE PNTR mfp,long offset,int ptrname));
int _cdecl mfil_read PROTO((CharPtr buf,size_t size,size_t nitems,MFILE PNTR mfp));
int _cdecl mfil_write PROTO((CharPtr buf,size_t size,size_t nitems,MFILE PNTR mfp));
int _cdecl	mfil_close PROTO((MFILE PNTR mfp));
int _cdecl	mfil_eof PROTO((MFILE PNTR mfp));
#endif
int _cdecl	mfil_maplen PROTO((int newlen));
CharPtr _cdecl	mfil_get PROTO((MFILE PNTR mfp, size_t len));
void _cdecl	mfil_prefetch PROTO((MFILE PNTR mfp));
long PNTR _cdecl	 mfil_get_long PROTO((MFILE PNTR mfp, size_t nelem));
size_t _cdecl	mfil_dup_long PROTO((MFILE PNTR mfp,long PNTR i,size_t nelem));
size_t _cdecl	 mfil_put_long PROTO((MFILE PNTR mfp, long PNTR i, size_t nelem));


/* System level functions */
long _cdecl		sys_filesize PROTO((CharPtr fname));
void _cdecl		sys_times PROTO((Cputime_t PNTR t));
void _cdecl		sys_showtime PROTO((CharPtr str, Cputime_t PNTR t0, Cputime_t PNTR t1, FILE *fp));
CharPtr _cdecl	sys_whoami PROTO((void));

/* Random number generator */
void _cdecl		rnd_seed PROTO((long seed));
long _cdecl		rnd_gen PROTO((void));

/* Heap sort */
#ifndef hsort
void _cdecl	hsort PROTO((Nlm_VoidPtr base, size_t nel, size_t width, int (_cdecl *) (Nlm_VoidPtr,Nlm_VoidPtr)));
#endif
void _cdecl	hsort1 PROTO((Nlm_VoidPtr base, size_t nel, size_t width, int (_cdecl *) (Nlm_VoidPtr,Nlm_VoidPtr,Nlm_VoidPtr), Nlm_VoidPtr onearg));

/* AVL trees */
void _cdecl	avl_init PROTO((CharPtr tree));
CharPtr _cdecl	avl_srch PROTO((CharPtr tree, FnPtr compar, CharPtr key));
void _cdecl	avl_add PROTO((CharPtr tree, FnPtr compar, CharPtr key, int (PNTR delet)()));
Boolean _cdecl	avl_delete PROTO((CharPtr tree, FnPtr compar, CharPtr key, FnPtr
delet));
Boolean _cdecl	avl_trav PROTO((CharPtr tree, FnPtr trav));

/* Numerical functions */
double _cdecl	fct_powi PROTO((double x, int power));	/* Integral powers of x */
long _cdecl	fct_gcd PROTO((long a, long b)); /* Greatest Common Divisor */
long _cdecl	fct_nint PROTO((double x));	/* Round to nearest long integer */
double _cdecl	fct_factorial PROTO((long n));	/* n! */
double _cdecl	fct_ntakek PROTO((unsigned long n, unsigned long k));
double _cdecl	fct_gammln PROTO((double x)); /* ln[gamma(x)] */
double _cdecl	fct_gamma PROTO((double x)); /* ln[gamma(x)] */
double _cdecl	fct_expm1 PROTO((double x)); /* accurate exp(x)-1 for all x */
double _cdecl	fct_log1p PROTO((double x)); /* accurate log(1+x) for valid x */
double _cdecl	fct_dbl_min PROTO((void)); /* min. value for a double */
float _cdecl	fct_flt_min PROTO((void)); /* min. value for a float */

	/* Bisection & Newton-Raphson root finder */
double _cdecl	fct_bisnr PROTO((double, double (PNTR)(), double (PNTR)(), double, double, double, double));

	/* System-dependent functions */

GdbmPtr _cdecl gdbm_open PROTO((CharPtr fname, int flags, int mode));
void _cdecl gdbm_close PROTO((GdbmPtr));
int _cdecl gdbm_add PROTO((GdbmPtr db, Nlm_VoidPtr key, size_t keylen, Nlm_VoidPtr data, size_t datalen));
int _cdecl gdbm_write PROTO((GdbmPtr db, Nlm_VoidPtr key, size_t keylen, Nlm_VoidPtr data, size_t datalen));
int _cdecl gdbm_read PROTO((GdbmPtr db, Nlm_VoidPtr key, size_t keylen, Nlm_VoidPtr data, size_t datalen));
int _cdecl gdbm_wlock PROTO((GdbmPtr));
int _cdecl gdbm_rlock PROTO((GdbmPtr));
int _cdecl gdbm_unlock PROTO((GdbmPtr));

void _cdecl critical_begin();
void _cdecl critical_end();

AlarmBlkPtr	AlarmSet PROTO((time_t when, FnPtr func, VoidPtr arg));
AlarmBlkPtr	AlarmEvery PROTO((time_t period, FnPtr func, VoidPtr arg));
time_t	AlarmWhen PROTO((void));
void	AlarmReset PROTO((AlarmBlkPtr,time_t));
void	AlarmClr PROTO((AlarmBlkPtr));
void	AlarmClrAll PROTO((void));

PatTreePtr	PatTreeNew PROTO((Nlm_VoidPtr (*keyfunc)(Nlm_VoidPtr), VoidPtr firstkey));
int			PatTreeInit PROTO((PatTreePtr ptp, Nlm_VoidPtr (*keyfunc)(Nlm_VoidPtr), VoidPtr firstkey));
void		PatTreeReinit PROTO((PatTreePtr ptp));
void		PatTreeFree PROTO((PatTreePtr));
void		PatTreeDestruct PROTO((PatTreePtr));
PatNodePtr	PatNodeNew PROTO((PatTreePtr));
PatNodePtr	PatFindNode PROTO((PatTreePtr ptp, VoidPtr key));
PatNodePtr	PatFindNodeLen PROTO((PatTreePtr ptp, VoidPtr key, size_t keylen));
PatNodePtr	PatFindNodeCmp PROTO((PatTreePtr ptp, VoidPtr key, size_t keylen));
PatNodePtr	PatInsert PROTO((PatTreePtr ptp, VoidPtr key));
PatNodePtr	PatInsertNode PROTO((PatTreePtr ptp, PatNodePtr node, VoidPtr key));

#endif /* !__GISHLIB__ */
