/* lu2s -- convert an unsigned long integer to ASCII */

#include <ncbi.h>
#include <gishlib.h>

#define NBUFS   20	/* No. of static buffers for the ASCII results */

/*
Change THOUSANDS_DEFAULT for the international scene,
or define it as NULLB if no markers are desired.
*/
#define THOUSANDS_DEFAULT	','

char * _cdecl
lu2s(value)
	register unsigned long	value;
{
	register unsigned long	quotient;
	register char	*  bp;
    register unsigned long	divisor = (1000*1000*1000);
	register char	*bp0;
	register unsigned long	ovalue = value;
	static int	bufno = 0;
	static char	buf[NBUFS][(CHAR_BIT)*sizeof(unsigned long)/2];
	static char	thousands = THOUSANDS_DEFAULT;

    bp = bp0 = &buf[bufno][0];
	if (++bufno >= DIM(buf))
		bufno = 0;

	if (value == 0) {
		*bp++ = '0';
		*bp = NULLB;
		return bp0;
	}

	while (divisor > value)
		divisor /= 10;

    *bp++ = '0' + (quotient = (value / divisor));
    value -= quotient * divisor;

    while ((divisor /= 10) > 0) {
		/* Only insert thousands when value >= 10000 (the Macintosh way) */
        if (ovalue >= (10*1000)
				&& (divisor == 100
					|| divisor == (100*1000)
					|| divisor == (100*1000*1000))
				&& thousands != NULLB)
			*bp++ = thousands;
        quotient = value / divisor;
        *bp++ = '0' + quotient;
        value -= quotient * divisor;
    }
    *bp = NULLB;
    return bp0;
}
